<?php
/*
Plugin Name: LoxlyRSS
Plugin URI: http://www.niftyplugins.com/loxlyrss-wordpress-plugin/
Description: loxlyrss uses RSS to display Loxly Gallery rss feeds. Insert &quot;[loxlyrss:IMGSIZE,SASID,TRKCODE,URL]&quot; into a post or page.  Replace &quot;IMGSIZE&quot; with the image width you want to show... 100-500.  (Widths over 300 may be blurred on portrait images)  Replace &quot;SASID&quot; with your ShareASale ID number.  Replace &quot;TRKCODE&quot; with a Tracking code. Replace &quot;URL&quot; with the URL of the RSS feed starting with &quot;http://&quot;.
Author: Kent Lorentzen
Author URI: http://www.niftyplugins.com/loxlyrss-wordpress-plugin/
Version: 0.14
*/

function loxlyrss($content) {

	// --- Initialize ---
	require_once (ABSPATH . WPINC . '/rss-functions.php');

	// --- Arrays ---
	$find[] = "";
	$replace[] = "";
		
	// --- Search ---
	// Find all "[loxlyrss:*]"
	preg_match_all('/\[loxly(list|para|rss):(\S+)\]/', $content, $matches, PREG_SET_ORDER);

	// For each one you find...
	foreach ($matches as $val) {
		$lginfo = explode(",",$val[2]);

		$lgimagesize = $lginfo[0];				
		$sasid = $lginfo[1];
		$sasafftrack = $lginfo[2];		
		$url = html_entity_decode($lginfo[3]);
		
		// --- Get defaults if nothing entered ---
		if ($lgimagesize == "IMGSIZE") {
			$lgimagesize = get_option('loxlyrss_imagesize');
		}
		
		if ($sasid == "SASID") {
			$sasid = get_option('loxlyrss_sasid');
		} 

		if ($sasafftrack == "TRKCODE") {
			$sasafftrack = get_option('loxlyrss_afftrack');
		} 
 
		$sasaffcode = "http://www.shareasale.com/r.cfm?u=" . $sasid . "&b=148114&m=12245&afftrack=" . $sasafftrack . "&urllink=loxlygallery.com/";
		
		// --- Syntax Display ---
		if (strtoupper($url) == "URL") {
			$disp = $val[0];

		// --- Get RSS ---
		} elseif ($rss = fetch_rss($url)) {

					// Set Variables
					if ($lgimagesize < "100") {
						$lgimagesize = "100";
						}
						
						if ($lgimagesize > "500") {
						$lgimagesize = "500";
						}
					
					// Image
					if ($rss->image[url] != '') {
						$title = $rss->image[title];
						$link = htmlentities($rss->image[link]);
						$url = $rss->image[url];
						$disp .= "\t<a href='$link'><img src='$url' alt='$title' /></a><br />\n";
					}
					
					// Title, copyright, and description
					$title = $rss->channel[title];
					$title = str_replace(": RSS Products Feed ::","-",$title );
					$copy = $rss->channel[copyright];
					$link = htmlentities($rss->channel[link]);					
					$link = str_replace("http://loxlygallery.com/",$sasaffcode,$link );
					if (get_option('loxlyrss_lgwindow') == "new") {
						$link = $link . "' TARGET='_blank'";
					}

					$desc = $rss->channel[description];

					$disp .= "\t<big><a href='$link'>$title</a></big><br />\n";
					if ($copy != '') $disp .= "\t<small>$copy</small><br />\n";
					$disp .= "\n\t<br />\n";

					// For each item...
					foreach($rss->items as $item) {
						$title = $item[title];
						$lgbrand = $item["g"] [brand];
						$lgbrand = "by " . $lgbrand;
						$lgprice = $item["g"] [price];
						$lgprice = "Prices for giclee prints starting at $" . $lgprice;
						$link = htmlentities($item[link]);
						$link = str_replace("http://loxlygallery.com/",$sasaffcode,$link );
						$link = str_replace("&amp;","%26",$link );
						
						if (get_option('loxlyrss_lgwindow') == "new") {						
							$link = $link . "' TARGET='_blank'";
						}
						$desc = $item[description];
						
						$desc = str_replace("http://loxlygallery.com/index",$sasaffcode . "index",$desc );
						$desc = str_replace("&products","%26products",$desc );
						$desc = str_replace("&action","%26action",$desc );												
						$desc = str_replace("</a>","</a><br /><br />",$desc );
						
						$lgdesc = explode("<br /><br />", $desc, 3);
						
						$lgdescimg = $lgdesc[0];
						
						$lgimgtemp = explode("width", $lgdescimg, 2);
						
						$lgdescimg = $lgimgtemp[0] . "'width='" . $lgimagesize . "' /></a>";
						
						$lgdesctext = $lgdesc[1];
						$lgdescbuy = $lgdesc[2];
						
						// ---- Send formatted feed to WP ---						
						if ($title != '') {
						$disp .= "\t<P><b><a href='$link'>$title</a></b><br />\n";
						$disp .= "\t$lgbrand\n</P>";
						$disp .= "\t<P>$lgdescimg\n</P>";
						$disp .= "\t<P>$lgdesctext\n</P>";
							if (get_option('loxlyrss_lgshowprice') == "yes") {						
								$disp .= "\t<P>$lgprice\n</P>";
							}
							if (get_option('loxlyrss_lgbuynow') == "yes") {						
								$disp .= "\t<P>$lgdescbuy\n</P>";
							}
						}
					}

		// --- Not Found ---
		} else {
			$disp = "\nloxlyrss ERROR: &quot;$url&quot; NOT FOUND!<br />\n";
		}

		// --- Replace ---
		$find = $val[0];
		$replace = $disp;
	}

	// --- Return ---
	return str_replace($find, $replace, $content) . $appendage;
}

// --- Filter ---
add_filter('the_content', 'loxlyrss');

// --- Options Menu ---
function set_loxlyrss_defaults() {
	add_option('loxlyrss_imagesize','200','Image size');
	add_option('loxlyrss_sasid','202591','Plugin author ID');
	add_option('loxlyrss_afftrack','loxlyrss','Tracking code');
	add_option('loxlyrss_lgwindow','same','Open links');
	add_option('loxlyrss_lgshowprice','no','Show price');
	add_option('loxlyrss_lgbuynow','yes','Buy now');
}

function unset_loxlyrss_defaults() {
	delete_option('loxlyrss_imagesize');
	delete_option('loxlyrss_sasid');
	delete_option('loxlyrss_afftrack');
	delete_option('loxlyrss_lgwindow');
	delete_option('loxlyrss_lgshowprice');
	delete_option('loxlyrss_lgbuynow');
}

register_activation_hook(__FILE__,'set_loxlyrss_defaults');

function admin_loxlyrss_options() {
	?><div class="wrap"><h2>loxlyrss Options</h2><?php
	
	if ($_REQUEST['submit']) {
		update_loxlyrss_options();
	}
	print_loxlyrss_form();
	
	?></div><?php

}

function update_loxlyrss_options() {
		$ok = false;
		
		//  You probably want some input validation in here
		if ($_REQUEST['loxlyrss_imagesize']) {
			 update_option('loxlyrss_imagesize',$_REQUEST['loxlyrss_imagesize']);
			 $ok = true;
		}
		//  You probably want some input validation in here
		if ($_REQUEST['loxlyrss_sasid']) {
			 update_option('loxlyrss_sasid',$_REQUEST['loxlyrss_sasid']);
			 $ok = true;
		}
		//  You probably want some input validation in here
		if ($_REQUEST['loxlyrss_afftrack']) {
			 update_option('loxlyrss_afftrack',$_REQUEST['loxlyrss_afftrack']);
			 $ok = true;
		}
		if ($_REQUEST['loxlyrss_lgwindow']) {
			 update_option('loxlyrss_lgwindow',$_REQUEST['loxlyrss_lgwindow']);
			 $ok = true;
		}
		if ($_REQUEST['loxlyrss_lgshowprice']) {
			 update_option('loxlyrss_lgshowprice',$_REQUEST['loxlyrss_lgshowprice']);
			 $ok = true;
		}
		if ($_REQUEST['loxlyrss_lgbuynow']) {
			 update_option('loxlyrss_lgbuynow',$_REQUEST['loxlyrss_lgbuynow']);
			 $ok = true;
		}
		
		if ($ok) {
			?><div id="message" class="updated fade">
				<p>Options saved.</p>
			</div><?php
		}
		else {
			?><div id="message" class="error fade">
				<p>Failed to save options.</p>
			</div><?php
		}
}

function print_loxlyrss_form() {
		$default_imagesize = get_option('loxlyrss_imagesize');
		$default_sasid = get_option('loxlyrss_sasid');
		$default_afftrack = get_option('loxlyrss_afftrack');
		$default_lgwindow = get_option('loxlyrss_lgwindow');
		$default_lgshowprice = get_option('loxlyrss_lgshowprice');
		$default_lgbuynow = get_option('loxlyrss_lgbuynow');
		?>
		<form method="post">
				<label for="loxlyrss_imagesize">Select a default Image <B>Width</B> from 100-500 pixels:
						<input type="text" name="loxlyrss_imagesize" value="<?php echo $default_imagesize; ?>"
				</label> 
				<br />
				(Portrait image widths larger than 300 may be blurred.)<BR>				
				<br />
				<label for="loxlyrss_sasid">Set the default <B>SASID</B>:
						<input type="text" name="loxlyrss_sasid" value="<?php echo $default_sasid; ?>"
				</label> 
				<br />
				When first activated the default ShareASale ID is the plugin authors ID.<BR>
				Make sure you change it to your ID to get credit for affiliate sales.
				<br />
				<br />
				<label for="loxlyrss_afftrack">Default Tracking code:
						<input type="text" name="loxlyrss_afftrack" value="<?php echo $default_afftrack; ?>"
				</label> Letters and Numbers only - No spaces.
				<br />
				<br />
				<label for="loxlyrss_lgwindow">When a link is clicked:<BR>
						<P>
						<INPUT NAME="loxlyrss_lgwindow" TYPE="radio" VALUE="same" <?php if ($default_lgwindow == "same") echo "checked"; ?>> Open links in Same Window<BR>
						<INPUT NAME="loxlyrss_lgwindow" TYPE="radio" VALUE="new" <?php if ($default_lgwindow == "new") echo "checked"; ?>> Open links in New Window</P>
				</label>
				<br />
				<label for="loxlyrss_lgshowprice">Show or Hide the Price Line:<BR>
						<P>
						<INPUT NAME="loxlyrss_lgshowprice" TYPE="radio" VALUE="yes" <?php if ($default_lgshowprice == "yes") echo "checked"; ?>> Show Price line<BR>
						<INPUT NAME="loxlyrss_lgshowprice" TYPE="radio" VALUE="no" <?php if ($default_lgshowprice == "no") echo "checked"; ?>> Hide Price line</P>
				</label>
				<br />
				<label for="loxlyrss_lgshowprice">Show or Hide the 'Buy Now' button:<BR>
						<P>
						<INPUT NAME="loxlyrss_lgbuynow" TYPE="radio" VALUE="yes" <?php if ($default_lgbuynow == "yes") echo "checked"; ?>> Show Buy Now<BR>
						<INPUT NAME="loxlyrss_lgbuynow" TYPE="radio" VALUE="no" <?php if ($default_lgbuynow == "no") echo "checked"; ?>> Hide Buy Now</P>
				</label>
				<br />
				<input type="submit" name="submit" value="Submit" />
		</form>
		<HR>
		<BR>
		To display a Loxly Gallery RSS feed, paste this code on a new line in a post or page:<BR><BR>
		<B>[loxlyrss:IMGSIZE,SASID,TRKCODE,URL]</B><BR><BR>
		Be sure to include the starting and ending brackets.<BR><BR>
		Replace 'URL' with the URL of the RSS feed starting with 'http://'.<BR>
		(The URL for the feed is an Orange symbol and words that say 'RSS for this gallery' bottom of the gallery page.)<BR><BR>
		The gallery will be shown using the default settings.  You can change IMGSIZE,SASID,or TRKCODE if you want to use a different setting for that post.<BR><BR>
		<BR>
		<B>If you find this plugin useful...</B>  A link to anything in these <A HREF="http://loxlygallery.com/index.php?main_page=index&manufacturers_id=18&zenid=c4d359ed661ce0be8e10b9f5dafa1c33" TARGET="_blank" TITLE="Kent Lorentzen Galleries">galleries</A> would be appreciated.
		
<?php
}				

function add_loxlyrss_menu() {
	add_options_page(
						 	'loxlyrss',				// page title
							'loxlyrss',				// sub-menu name
							'manage_options',			// access/ca
							__FILE__,					// file
							'admin_loxlyrss_options'	// function
						);
}

add_action('admin_menu','add_loxlyrss_menu');
?>